// Shimilan IPS (SIPS)
// Version: Beta 1

#include <stdio.h>
#include <iostream.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char *argv[]){
  char *header;
  header = new char[6];
  char *offset;
  offset = new char[4];
  char *size;
  size = new char[3];
  char *rlesize;
  rlesize = new char[3];
  char *patch;
  patch = new char[1];
  char rlebyte;
  FILE *ipsfile, *patchfile;
  long ioffset, isize, irlesize, x;

  if (argc < 3){
    cout << "Invalid calling format." << endl << "FORMAT: " << argv[0] << " <ipsfile> <filetobepatched>" << endl << "Exitting program..." << endl;
    return 0;
  }

  if ((ipsfile = fopen(argv[1], "r")) == NULL){
    cout << "File not found: " << argv[1] << endl << "Exitting program..." << endl;
    return 0;
  }
  if ((patchfile = fopen(argv[2], "rb+")) == NULL){
    cout << "File not found: " << argv[2] << endl << endl << "Exitting program..." << endl;
    return 0;
  }
  fgets(header, 6, ipsfile);
   if (!strcmp(header, "PATCH")){
    cout << "File " << argv[1] << " recognized as patch." << endl;
  }
  else{
    cout << "File " << argv[1] << " not recognized as patch." << endl << "FORMAT: " << argv[0] << " <ipsfile> <filetobepatched>" << endl << "Exitting program..." << endl;
    return 0;
  }

   for (x = 0; x < 3; x++){
     offset[x] = fgetc(ipsfile);
   }
  while (!feof(ipsfile)){
    if (!strcmp(offset, "EOF")){
      cout << "Patching Complete!" << endl;
      return 0;
    }
    ioffset = (int)(unsigned char)offset[0] * (int)pow(16, 4) +
      (int)(unsigned char)offset[1] * (int)pow(16, 2) + (int)(unsigned
							      char)offset[2] * (int)pow(16, 0);
    for (x = 0; x < 2; x++){
      size[x] = fgetc(ipsfile);
    }
    isize = (int)(unsigned char)size[0] * (int)pow(16, 2) + (int)(unsigned char)size[1];
    
    // This is where we check for RLE format
    if (isize == 0){
      // cout << "RLE called! Offset: " << ioffset;
      for (x = 0; x < 2; x++){
	rlesize[x] = fgetc(ipsfile);
      }
      irlesize = (int)(unsigned char)rlesize[0] * (int)pow(16, 2) + (int)(unsigned char)rlesize[1];
      // cout << "  Length: " << irlesize << endl;
      rlebyte = fgetc(ipsfile);
      if (fseek(patchfile, ioffset, SEEK_SET)){
	cout << "ERROR: Could not seek to requested position in patched file" << endl << "(Perhaps file is incorrect or incomplete?)" << endl << "Exitting program..." << endl;
	return 0;
      }
      for (x = 0; x < irlesize; x++){
	fputc(rlebyte, patchfile);
      }
      for (x = 0; x < 3; x++){
	offset[x] = fgetc(ipsfile);
      }
      continue;
    }
    
    if ((patch = (char *)malloc(isize + 1)) == NULL){
      cout << "ERROR: Memory could not be allocated" << endl << "Exitting program..." << endl;
      return 0;
    }
    

    //    if (fgets(patch, isize + 1, ipsfile) == NULL){  // patch now has the full patch
    //      cout << "ERROR: patch couldn't be received!" << endl;
    //      return 0;
    //    }

    if (fseek(patchfile, ioffset, SEEK_SET)){
      cout << "ERROR: Could not seek to requested position in patched file" << endl << "(Perhaps file is incorrect or incomplete?)" << endl << "Exitting program..." << endl;
      return 0;
    }

    for (x = 0; x < isize; x++){
      patch[0] = fgetc(ipsfile);
      fputc(patch[0], patchfile);
    }

    //    if (fputs(patch, patchfile) == EOF){
    //      cout << "ERROR: Could not write full patch to file." << endl << "(Perhaps file is incorrect or incomplete?)" << endl << "Exitting program..." << endl;
    //      return 0;
    //    }
    // fgets(offset, 4, ipsfile);

    for (x = 0; x < 3; x++){
      offset[x] = fgetc(ipsfile);
    }
  }
  
  fclose(patchfile);
  fclose(ipsfile);
}


